chiark / gitweb /
bash_profile: Make editor selection indirect via a script mdw-editor.
[profile] / setup
CommitLineData
65ff0e8c 1#! /bin/bash
f617db13
MW
2
3set -e
4
5umask 002
6
4aa875e9 7sub=
f617db13
MW
8mkdir -p $HOME$sub
9
0633739b 10: ${REPO=http://guvnor.distorted.org.uk/ftp/pub/mdw/profile}
f617db13
MW
11
12export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
13
14### Sort out command line
15xstuff= false=
16while [ $# -gt 0 ]; do
17 case "$1" in
18 -x) xstuff=t;;
19 -n) false=false;;
20 --) shift; break;;
21 -*) echo >&2 "$0: bad option"; exit 1;;
22 *) break;;
23 esac
24 shift
25done
26
27### Find out where I am
28here=$(pwd)
f617db13
MW
29
30### Suss out how to print things
31out=$(echo -n "foo"; echo "bar")
32if [ "$out" = "foobar" ]; then
33 echon="echo -n"
34 echoc=""
35else
36 echon="echo"
37 echoc='\c'
38fi
39
40### Create the necessary directories
41echo "Creating directories..."
42for i in bin lib/emacs src; do
43 $echon " $i:$echoc"
44 if [ -d $HOME$sub/$i ]; then
45 echo " already exists."
46 else
47 mkdir -p $HOME$sub/$i
48 echo " done."
49 fi
50done
852cd5fb 51echo " all done."
f617db13
MW
52
53### Find out how to fetch things over the net
54$echon "Finding URL fetcher:$echoc"
55if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
56 GETURL="curl -fs -o"
57 echo " curl."
58elif wget >/dev/null 2>&1 --version; then
59 GETURL="wget -q -O"
60 echo " wget."
61else
62 echo " failed!"
63 echo >&2 "$0: failed to find URL fetcher"
64 exit 1
65fi
66
67### Install necessary things
68echo "Installing useful scripts..."
69
af58d83c 70scripts="
370d4c8d 71 lesspipe.sh start-ssh-agent svnwrap movemail-hack"
af58d83c
MW
72[ "$xstuff" ] && scripts="$scripts
73 xrun"
74for script in $scripts; do
f617db13
MW
75 $echon " $script:$echoc"
76 found=
77 for p in /bin /usr/bin /usr/local/bin $(echo $PATH | tr : ' '); do
78 if $false [ -x $p/$script ]; then
79 found=t
80 break
81 fi
82 done
83 if [ "$found" ]; then
84 echo " already installed."
85 else
86 $echon " downloading$echoc"
87 $GETURL $HOME$sub/bin/$script $REPO/$script
88 chmod +x $HOME$sub/bin/$script
89 echo " done."
90 fi
91done
92
852cd5fb 93echo " all done."
f617db13
MW
94
95### Install some more complicated programs
96echo "Installing packages..."
97systems="
98 mLib:2.0.3:mLib-config
99 chkpath:1.1.0:tmpdir
100"
101[ "$xstuff" ] && systems="$systems
102 mgLib:1.1.0:mgLib-config
103 xtoys:1.3.0:xscsize
104"
105for system in $systems; do
106 set -- $(echo $system | tr : ' ')
107 sys=$1 ver=$2 prog=$3
108 $echon " $sys:$echoc"
109 if $false $prog >/dev/null 2>&1 --version; then
110 echo " already installed."
111 else
112 ( set -e
113 $echon " downloading$echoc"
114 cd $HOME$sub/src
115 rm -rf $sys-$ver.tar.gz $sys-$ver
116 $GETURL $sys-$ver.tar.gz $REPO/$sys-$ver.tar.gz
117 $echon " unpacking$echoc"
118 gzip -cd $sys-$ver.tar.gz | tar xf -
119 $echon " configuring$echoc"
120 cd $sys-$ver
121 mkdir build
122 cd build
123 ../configure --prefix=$HOME$sub >>buildlog 2>&1
124 $echon " building$echoc"
125 make >>buildlog 2>&1
126 $echon " installing$echoc"
127 make install >>buildlog 2>&1
128 echo " done."
129 )
130 fi
131done
852cd5fb 132echo " all done."
f617db13 133
f141fe0f
MW
134### Install global configuration
135echo -n "Installing dotfile configuration:"
136if [ -f $HOME$sub/.mdw.conf ]; then
137 echo " already installed."
138else
139 cp mdw.conf $HOME$sub/.mdw.conf
140 echo " done."
141fi
142
f617db13 143### Symlink the various dotfiles into place
852cd5fb 144dotfiles="
be7dba95 145 bash_profile bash_logout bashrc inputrc bash_completion
852cd5fb 146 emacs emacs-calc
a124320a 147 vm mailrc signature
75d08fb2 148 gitconfig cgrc tigrc
ccaac00b
MW
149 lisp-init.lisp:.cmucl-init.lisp
150 lisp-init.lisp:.sbclrc
151 lisp-init.lisp:.clisprc.lisp
f6335a0c 152 lisp-init.lisp:.eclrc
2425eca9 153 dircolors colordiffrc screenrc cvsrc indent.pro"
739bccbf 154[ "$xstuff" ] && dotfiles="$dotfiles
eae29a8c 155 xinitrc xsession Xdefaults vncrc vncsession
739bccbf
MW
156 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
157 e-keybindings.cfg:.enlightenment/keybindings.cfg
eae29a8c 158 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
739bccbf 159 jue-peek.jpg:.enlightenment/backgrounds/jue-peek.jpg"
f617db13
MW
160echo "Installing dotfiles..."
161for d in $dotfiles; do
739bccbf
MW
162 target=.$d
163 case $d in
164 *:*) target=${d#*:} d=${d%%:*};;
165 esac
166 ft=$HOME$sub/$target
167 dir=${ft%/*}
168 mkdir -p $dir
169 ln -s $here/$d $ft.new
170 mv $ft.new $ft
171 echo " $target"
f617db13 172done
852cd5fb 173echo " all done."
f617db13 174
e04c4857
MW
175### Install useful scripts included in this package
176scripts="
177 mdw-editor"
178echo "Installing scripts..."
179mkdir -p $HOME$sub/bin
180for s in $scripts; do
181 ft=$HOME$sub/bin/$s
182 ln -s $here/$s $ft.new
183 mv $ft.new $ft
184 echo " $s"
185done
186echo " all done."
187
f617db13 188### Set up the Emacs config
65ff0e8c
MW
189$echon "Finding a suitable emacs:$echoc"
190emacs=no
191for i in emacs21 emacs; do
192 if type -p >/dev/null $i; then
193 emacs=$i
194 break
195 fi
196done
197if [ $emacs = no ]; then
198 echo " failed."
199 emacs=:
200else
201 echo " $emacs."
202fi
203
f617db13 204echo "Installing Emacs packages..."
400223a1
MW
205emacspkg="
206 make-regexp
207 git vc-git
208 quilt"
209for elib in $emacspkg; do
f617db13 210 $echon " $elib:$echoc"
65ff0e8c 211 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
20eb0692 212 (progn
852cd5fb
MW
213 (setq load-path (nconc load-path (list "~/lib/emacs")))
214 (kill-emacs (condition-case nil
215 (progn (load-library "'"$elib"'") 0)
20eb0692 216 (error 1))))'; then
f617db13
MW
217 echo " already installed."
218 else
219 $echon " downloading$echoc"
20eb0692 220 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
f617db13
MW
221 $echon " compiling$echoc"
222 (cd $HOME$sub/lib/emacs;
65ff0e8c 223 $emacs >/dev/null 2>&1 --no-site-file --batch \
20eb0692 224 --eval '(byte-compile-file "'"$elib.el"'")')
f617db13
MW
225 echo " done."
226 fi
227done
852cd5fb 228echo " all done."
f617db13
MW
229
230$echon "Setting up Emacs configuration:$echoc"
231$echon " linking$echoc"
232for link in dot-emacs.el:dot-emacs.el emacs-Makefile:Makefile; do
233 set -- $(echo $link | tr : ' ')
234 from=$1 to=$2
739bccbf
MW
235 ln -s $here/$from $HOME$sub/lib/emacs/$to.new
236 mv $HOME$sub/lib/emacs/$to.new $HOME$sub/lib/emacs/$to
f617db13
MW
237done
238$echon " compiling$echoc"
65ff0e8c 239make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
f617db13 240echo " done."